import type { Either, ErrorResolver } from '@lokalise/node-core';
import type { QueueConsumer, NewQueueOptions, ExistingQueueOptions } from '@message-queue-toolkit/core';
import type { Message } from 'amqplib';
import type { AMQPConsumerDependencies, CreateAMQPQueueOptions } from './AbstractAmqpService';
import { AbstractAmqpService } from './AbstractAmqpService';
export type AMQPLocatorType = {
    queueName: string;
};
export type NewAMQPConsumerOptions = NewQueueOptions<CreateAMQPQueueOptions>;
export type ExistingAMQPConsumerOptions = ExistingQueueOptions<AMQPLocatorType>;
export declare abstract class AbstractAmqpBaseConsumer<MessagePayloadType extends object> extends AbstractAmqpService<MessagePayloadType, AMQPConsumerDependencies> implements QueueConsumer {
    private readonly transactionObservabilityManager?;
    protected readonly errorResolver: ErrorResolver;
    constructor(dependencies: AMQPConsumerDependencies, options: NewAMQPConsumerOptions | ExistingAMQPConsumerOptions);
    abstract processMessage(messagePayload: MessagePayloadType, messageType: string): Promise<Either<'retryLater', 'success'>>;
    private deserializeMessage;
    start(): Promise<void>;
    protected resolveMessage(message: Message): Either<import("@message-queue-toolkit/core").MessageInvalidFormatError | import("@message-queue-toolkit/core").MessageValidationError, unknown>;
}
