import type { Either } from '@lokalise/node-core';
import type { QueueConsumer, MultiSchemaConsumerOptions } from '@message-queue-toolkit/core';
import { HandlerContainer, MessageSchemaContainer } from '@message-queue-toolkit/core';
import type { NewAMQPConsumerOptions } from './AbstractAmqpBaseConsumer';
import { AbstractAmqpBaseConsumer } from './AbstractAmqpBaseConsumer';
import type { AMQPConsumerDependencies } from './AbstractAmqpService';
export declare abstract class AbstractAmqpConsumerMultiSchema<MessagePayloadType extends object, ExecutionContext> extends AbstractAmqpBaseConsumer<MessagePayloadType> implements QueueConsumer {
    messageSchemaContainer: MessageSchemaContainer<MessagePayloadType>;
    handlerContainer: HandlerContainer<MessagePayloadType, ExecutionContext>;
    constructor(dependencies: AMQPConsumerDependencies, options: NewAMQPConsumerOptions & MultiSchemaConsumerOptions<MessagePayloadType, ExecutionContext>);
    protected resolveSchema(message: MessagePayloadType): Either<Error, import("zod").ZodType<MessagePayloadType, import("zod").ZodTypeDef, MessagePayloadType>>;
    processMessage(message: MessagePayloadType, messageType: string): Promise<Either<'retryLater', 'success'>>;
}
