"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AbstractAmqpConsumerMultiSchema = void 0;
const core_1 = require("@message-queue-toolkit/core");
const AbstractAmqpBaseConsumer_1 = require("./AbstractAmqpBaseConsumer");
class AbstractAmqpConsumerMultiSchema extends AbstractAmqpBaseConsumer_1.AbstractAmqpBaseConsumer {
    messageSchemaContainer;
    handlerContainer;
    constructor(dependencies, options) {
        super(dependencies, options);
        const messageSchemas = options.handlers.map((entry) => entry.schema);
        this.messageSchemaContainer = new core_1.MessageSchemaContainer({
            messageSchemas,
            messageTypeField: options.messageTypeField,
        });
        this.handlerContainer = new core_1.HandlerContainer({
            messageTypeField: this.messageTypeField,
            messageHandlers: options.handlers,
        });
    }
    resolveSchema(message) {
        return this.messageSchemaContainer.resolveSchema(message);
    }
    async processMessage(message, messageType) {
        const handler = this.handlerContainer.resolveHandler(messageType);
        // @ts-ignore
        return handler(message, this);
    }
}
exports.AbstractAmqpConsumerMultiSchema = AbstractAmqpConsumerMultiSchema;
//# sourceMappingURL=AbstractAmqpConsumerMultiSchema.js.map