"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AbstractAmqpPublisherMultiSchema = void 0;
const core_1 = require("@message-queue-toolkit/core");
const AbstractAmqpService_1 = require("./AbstractAmqpService");
class AbstractAmqpPublisherMultiSchema extends AbstractAmqpService_1.AbstractAmqpService {
    messageSchemaContainer;
    constructor(dependencies, options) {
        super(dependencies, options);
        const messageSchemas = options.messageSchemas;
        this.messageSchemaContainer = new core_1.MessageSchemaContainer({
            messageSchemas,
            messageTypeField: options.messageTypeField,
        });
    }
    publish(message) {
        const resolveSchemaResult = this.resolveSchema(message);
        if (resolveSchemaResult.error) {
            throw resolveSchemaResult.error;
        }
        resolveSchemaResult.result.parse(message);
        this.channel.sendToQueue(this.queueName, (0, core_1.objectToBuffer)(message));
    }
    /* c8 ignore start */
    resolveMessage() {
        throw new Error('Not implemented for publisher');
    }
    /* c8 ignore stop */
    resolveSchema(message) {
        return this.messageSchemaContainer.resolveSchema(message);
    }
}
exports.AbstractAmqpPublisherMultiSchema = AbstractAmqpPublisherMultiSchema;
//# sourceMappingURL=AbstractAmqpPublisherMultiSchema.js.map